﻿<template>
  <div class="content-grid content-grid--subpage content-grid--subpage-table">  
    <BackLinkTitle :title="t('routes.grille.children.grilles.name')" />
    <div style="margin-top:60px" class="content-grid__header">
      <h1 class="back-link-title">
        {{ t(`routes.grille.children.grilles.name`) }}
      </h1>
      <div class="content-grid__filters">
        <!--<SearchInput v-model="searchValue" />-->
        <div class="filter-container">
          <label for="coursSelector">Sélectionnez un cours</label>
          <select
            id="coursSelector"
            v-model="selectedCours"
            @change="onCoursChange"
            class="custom-select"
          >
            <option
              v-for="cours in listeCours"
              :key="cours.id"
              :value="cours.id"
            >
              {{ cours.code }}
            </option>
          </select>
        </div>
      </div>
      <div class="content-grid__filters">
        <!--<SearchInput v-model="searchValue" />-->
        <div class="filter-container">
          <label for="grilleSelector">Sélectionnez une grille</label>
          <select
            id="grilleSelector"
            v-model="selectedGrille"
            @change="onGrilleChange"
            class="custom-select"
          >
            <option
              v-for="grille in listeGrilleAffichee"
              :key="grille.id"
              :value="grille.id"
            >
              {{ grille.titre }}
            </option>
          </select>
        </div>
      </div>
    </div>

    <Card>
      <div class="course-info">
        <h1>
          Cours :<span v-if="grille?.cours">
            {{ grille?.cours?.code }} - {{ grille?.cours?.nomCours }}</span
          >
        </h1>
        Épreuve : {{ grille?.titre }}
        <div class="nombre-totale">
          Copies Corigées :
          <span v-if="nbTotal && nombreCorriges < nbTotal" class="not-complete"
            >{{ nombreCorriges }} / {{ nbTotal }}</span
          >
          <span v-if="nbTotal && nombreCorriges == nbTotal" class="complete"
            >{{ nombreCorriges }} / {{ nbTotal }}</span
          >
        </div>
      </div>
    </Card>
    <div class="content-grid__filters">
      <div class="filter-container">
        <label for="groupeSelector">Sélectionnez un groupe : </label>
        <select
            id="groupeSelector"
            v-model="searchValue"
            @change="onGroupChange"
            class="custom-select"
        >
          <option
              v-for="groupe in listeGroupes"
              :key="groupe"
              :value="groupe"
          >
            {{ groupe }}
          </option>
        </select>
        <button @click="clearInput" class="btn">Effacer filtre</button>
      </div>
    </div>
   
    <!-- Select pour le groupe, reste a faire ca-->
   
    <Card v-if="grille">
      <DataTable
        v-if="grille?.cours.etudiantsCours"
        :headers="grilleHeader"
        :search-value="searchValue"
        :is-loading="enChargement"
        :items="grille?.cours?.etudiantsCours"
      />
      
      <div v-else>Aucun étudiant disponible. <RouterLink class="link" :to="'/fr/cours/' + grille.cours.id + '/details'">Importz-en</RouterLink></div>
    </Card>

    <button
      v-if="grille && grille?.cours.etudiantsCours && nombreCorriges == nbTotal"
      class="btn btn--fullscreen"
      @click="onExportEtudiants"
    >
      {{ t("global.exporter") }}
    </button>
  </div>
</template>

<script lang="ts" setup>
import i18n from "@/i18n";
import JSZip, { forEach } from "jszip";
import { saveAs } from "file-saver";
import jsPDF from "jspdf";
import { useI18n } from "vue3-i18n";
import { computed, onMounted, ref } from "vue";
import { useCoursService, useGrilleService } from "@/inversify.config";
import { notifyError, notifySuccess } from "@/notify";
import Card from "@/components/layout/Card.vue";
import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
import DataTable from "@/components/layout/DataTable.vue";
import { Grille } from "@/types/entities/grille";
import { EtudiantCours } from "../../types/entities/etudiantCours";
import { Guid } from "@/types";
import { GrilleService } from "../../services/grilleService";
import { Element } from "../../types/entities/creation-grille/Element";
import { Cours } from "../../types/entities/cours";
import { Etudiant } from "../../types/entities/etudiant";
    import { ElementEtudiant } from "../../types/entities/elementEtudiant";
    import { useMemberService } from "@/inversify.config";
    import { useMemberStore } from "@/stores/memberStore";
    import { Role } from "@/types";
import {Value} from "sass";
    const memberStore = useMemberStore()

let selectedGrille = "";
let selectedCours = "";
let selectedGroup = "";
const { t } = useI18n();
let nombreCorriges = 0;
let listeGrilles = ref<Grille[]>([]);
let listeGrilleAffichee = ref<Grille[]>([]);

let listeGroupes = ref<string[]>([]);

let nbTotal = 0;

let grilleHeader = [];
const grilleService = useGrilleService();
    const memberService = useMemberService();
let grille = ref<Grille | null>(null);

async function loadAllGrilles() {
  let grilles = await grilleService.getAllGrilles();
  if (grilles && grilles.length > 0) {
    listeGrilles.value = grilles;
  }
}

let listeCours = ref<Cours[]>([]);
const coursService = useCoursService();
let coursHeader = [];
let coursChoisi = ref<Cours | null>(null);

onMounted(async () => {
  await loadAllCours();
});

    async function loadAllCours() {
       
        var members = await memberService.getAllMembers();
        var userConncte = await memberService.getCurrentMember();
       
        const member = await members.find((x) => x.email === userConncte?.email);
        if (member != null && member.id != null) {
            const cours = await coursService.getAllCoursByMember(member?.id);
            if (cours && cours.length > 0) {
                listeCours.value = cours;
            }
        }

}

async function onGrilleChange() {
  let element = document.getElementById("grilleSelector") as HTMLSelectElement;
  await afficherGrille(element.value, "all");
}

function clearInput() {
  searchValue.value = "";
  onGrilleChange();

}

async function onGroupChange() {
  let grilleSelect = document.getElementById("grilleSelector") as HTMLSelectElement;
  let groupSelect = document.getElementById("groupeSelector") as HTMLSelectElement;
  await afficherGrille(grilleSelect.value, groupSelect.value);
}
let filteredGrilles = [];
async function onCoursChange() {
  nombreCorriges = 0;

  nbTotal = 0;
  grille.value = null;
  await loadAllGrilles();
  let cours = document.getElementById("coursSelector") as HTMLSelectElement;
  listeGrilleAffichee.value = [];

  if (cours) {
    (await coursChoisi?.value) !=
      listeCours?.value?.find((x) => x.id === cours.value);

    for (var i = 0; i < listeGrilles.value.length; i++) {
      if (listeGrilles.value[i].cours.id === cours.value) {
        listeGrilleAffichee.value.push(listeGrilles.value[i]);
      }
    }
  }
  return await listeGrilleAffichee;
}

let searchValue = ref("");
let enChargement = ref(false);

let tableGrilles = computed(() => {
  let lang = i18n.getLocale();

  return null;
});

let grill: Grille = new Grille();
grill.id = Guid.newGuid().toString();
grill.titre = "Grille 1";

let listeGrille: Grille[] = [new Grille()];
async function ObtenirNombreCorriges(listeEtudiantsCours: EtudiantCours[]) {
  let nombreNonCorriges = 0;
  nbTotal = listeEtudiantsCours.length;

  for (var i = 0; i < listeEtudiantsCours.length; i++) {
    var listeElementChaqueEtudiant = listeEtudiantsCours[i].etudiant
      .listeElementEtudiant as ElementEtudiant[];
    if (listeElementChaqueEtudiant != null) {
      for (var j = 0; j < listeElementChaqueEtudiant.length; j++) {
        let elemntEtud = listeElementChaqueEtudiant[j];
        if (elemntEtud.noteElement == null) {
          nombreNonCorriges++;
          break;
        }
      }
    }
  }
  nombreCorriges = listeEtudiantsCours.length - nombreNonCorriges;
}
async function afficherGrille(id: string, groupe: string) {
  grille.value = await grilleService.getGrille(id);

  nombreCorriges = 0;
  let etudiantGroupes = []
  nbTotal = 0;

  grilleHeader = [
    {
      text: "Da",
      value: "etudiant.da",
      sortable: true,
    },

    {
      text: "Nom",
      value: "etudiant.nom",
      sortable: true,
    },

    {
      text: "Prenom",
      value: "etudiant.prenom",
      sortable: true,
    },
      
    {
      text: "Groupe",
      value: "groupe",
      sortable: true,
    },
  ];
  coursHeader = [
    {
      text: "Code",
      value: "code",
      sortable: true,
      width: 300,
    },
    {
      text: "Nom Cours",
      value: "nomCours",
      sortable: true,
      width: 150,
    },
    {
      text: "",
      value: "actions",
      width: 75,
    },
  ];

    listeGroupes.value=[];
   
      for (var m = 0; m < grille.value.cours.etudiantsCours.length; m++) {
  
          if (grille.value.cours.etudiantsCours[m].groupe && !listeGroupes.value.includes(grille.value.cours.etudiantsCours[m].groupe!)) {
            listeGroupes.value.push(grille.value.cours.etudiantsCours[m].groupe!);

            
          }
      }
      if(groupe != "all"){
          grille.value.cours.etudiantsCours = grille.value.cours.etudiantsCours.filter(x =>x.groupe == groupe);         
      }

    
       console.log(grille.value.cours.etudiantsCours);

    
  if (grille.value.cours.etudiantsCours != null) {
    for (var i = 0; i < grille.value.cours.etudiantsCours.length; i++) {
      let listeElementsEtudiant = [];
      let etudiantDuCours = grille.value.cours?.etudiantsCours[i]
        ?.etudiant as Etudiant;
  
      if (grille.value.listeElementsEtudiants != null) {
        for (var j = 0; j < grille.value.listeElementsEtudiants.length; j++) {
          if (grille.value.listeElementsEtudiants[j] != null) {
            let etudiantElement: ElementEtudiant = grille.value.listeElementsEtudiants[j] as ElementEtudiant;
            if ( etudiantElement != null && etudiantDuCours.id == (etudiantElement.etudiant as Etudiant).id ) 
            
            {
                 listeElementsEtudiant.push(grille.value.listeElementsEtudiants[j]);       
            }
          }
        }
      }

      
      etudiantDuCours.listeElementEtudiant = listeElementsEtudiant;
    }
  }
  

  if (grille.value.element != null) {
    let listeElement = grille.value.element as Element[];
    for (var y = 0; y < listeElement.length; y++) {
      
        grilleHeader.push({
        text: listeElement[y].titre! + "/" + listeElement[y].ponderation!,
        value: `etudiant.listeElementEtudiant.${[y]}.noteElement`,
        sortable: true,
      });
    }
  }
  

  if (grille.value.cours.etudiantsCours != null) {
    await ObtenirNombreCorriges(grille.value.cours.etudiantsCours);
  }
}

async function onExportEtudiants() {
  let zip = new JSZip();
  const promises = grille.value?.cours.etudiantsCours.map(async (pGrille) => {
    let elementsEtudiant = grille.value?.listeElementsEtudiants?.filter(
      (x) => (x?.etudiant as Etudiant)?.id == pGrille.etudiant.id
    );
    const pdfContent = await generatePDF(
      pGrille,
      grille.value?.titre || "",
      grille.value?.cours.code || "",
      elementsEtudiant || []
    );
    zip.file(
      `${pGrille.etudiant.da}_${pGrille.etudiant.nom}_${pGrille.etudiant.prenom}.pdf`,
      pdfContent
    );
  });

  await Promise.all<void>(promises || []);

  zip.generateAsync({ type: "blob" }).then(function (content) {
    saveAs(content, "Travaux.zip");
  });
}

function generatePDF(
  grille: any,
  titre: string,
  codeCours: string,
  elementsEtudiant: any[]
) {
  const doc = new jsPDF();
  const pageWidth = doc.internal.pageSize.getWidth();
  const margin = 10;
  const elementFontSize = 15;
  const cardWidth = 180;
  const cardHeight = 0;
  const cardSpacing = 10;
  const lineHeight = 10;
  let ponderationTotal = 0;
  let noteFinaleEtudiant = 0;

  let currentPage = 1;
  let yPosition = margin;

  function addElement(element: any) {
    yPosition += lineHeight;
    const elementText = `-) ${element.elementEvalue.titre}`;
    let notePonderationText = `${element.noteElement} / ${element.elementEvalue.ponderation}`;
    noteFinaleEtudiant += element.noteElement;
    ponderationTotal += element.elementEvalue.ponderation;

    // Ajouter le texte de l'élément
    doc.setFont("helvetica", "bold");
    doc.setFontSize(elementFontSize);
    doc.text(elementText, margin, yPosition);
    doc.setFont("helvetica", "normal");
    doc.text(
        notePonderationText,
        pageWidth -
        margin -
        (doc.getStringUnitWidth(notePonderationText) * elementFontSize) /
        doc.internal.scaleFactor,
        yPosition
    );

    // Ajouter le critère de l'élément
    yPosition += lineHeight;
    doc.setFontSize(10);
    element.elementEvalue.critere.forEach((critere: any, index: number) => {
      const critereText = `Critère ${index + 1}: ${critere.detail}`;
      doc.text(critereText, margin, yPosition);
      yPosition += lineHeight;
    });

    // Ajouter les barèmes de l'élément
    let xPosition = margin;
    Object.values(element.elementEvalue.bareme).forEach((bareme: any) => {
      const baremeText = `${bareme.titre}: ${bareme.description}`;
      doc.setDrawColor(0);
      doc.setFillColor(255, 255, 255);
      doc.rect(xPosition, yPosition - 5, cardWidth, cardHeight, "F");
      const noteEnFonctionElementBareme =
          10 * (element.noteElement / element.elementEvalue.ponderation);
      doc.setTextColor(
          noteEnFonctionElementBareme >= bareme.minValue &&
          noteEnFonctionElementBareme <= bareme.maxValue
              ? "green"
              : "black"
      );
      doc.setFontSize(10);
      doc.text(baremeText, xPosition + 5, yPosition);
      doc.setTextColor("black");
      xPosition += cardWidth + cardSpacing;
      if (xPosition + cardWidth > pageWidth - margin) {
        xPosition = margin;
        yPosition += cardHeight + cardSpacing;
      }
    });

    // Réduction de l'espace entre les barèmes et les commentaires
    yPosition += cardHeight; // Ajustez cette ligne selon vos besoins

    // Ajouter le commentaire pour l'élément
    Object.values(element.elementEvalue.commentaire).forEach((commentaire: any) => {
      console.log({ commentaire });
      doc.setFont("helvetica", "normal");
      doc.setFontSize(10);
      doc.text(`Commentaires : ${commentaire.commentaire}`, margin, yPosition);
      yPosition += lineHeight;
    });
  }


  function addNewPageIfNeeded() {
    const elementHeight = lineHeight * 3;
    const spaceLeft = doc.internal.pageSize.getHeight() - yPosition;

    if (spaceLeft < elementHeight) {
      doc.addPage();
      yPosition = margin;
      currentPage++;
    }
  }

  // Ajouter le titre et les informations de base
  doc.setFontSize(18);
  doc.text(`Grille de correction de ${titre}`, margin, margin);
  doc.setFontSize(12);
  doc.text(`Cours : ${codeCours}`, margin, margin + 20);
  doc.text(
    `Nom de l'étudiant : ${grille.etudiant.prenom} ${grille.etudiant.nom}`,
    margin,
    margin + 30
  );
  doc.text(
    `Date de correction : ${new Date().toLocaleDateString()}`,
    margin,
    margin + 40
  );
  yPosition += 50;

  // Ajouter les éléments
  elementsEtudiant.forEach((element) => {
    addNewPageIfNeeded();
    addElement(element);
  });

  doc.setFont("helvetica", "bold");
  doc.setFontSize(14);
  doc.text(
    `Note finale : ${noteFinaleEtudiant} / ${ponderationTotal}`,
    margin,
    yPosition
  );
  return doc.output("arraybuffer");
  

}
</script>

<style scoped>
.filter-container {
  display: flex;
  align-items: center;
  margin-bottom: 10px;
}

.filter-container label {
  margin-right: 10px;
}
#groupeSelector {
  width: 10%;
  margin-right: 10px;
}
.custom-select {
  padding: 10px;
  font-size: 16px;
  border: 1px solid #ccc;
  border-radius: 4px;
  background-color: #f8f8f8;
  width: 100%;
  box-sizing: border-box;
  appearance: none;
  -webkit-appearance: none;
  -moz-appearance: none;
  background: url('data:image/svg+xml;utf8,<svg fill="none" height="24" viewBox="0 0 24 24" width="24" xmlns="http://www.w3.org/2000/svg"><path d="M7 10l5 5 5-5z"/><path d="M0 0h24v24H0z" fill="none"/></svg>')
    no-repeat right 0.75rem center/16px 16px;
}
.custom-select option {
  padding: 10px;
  font-size: 16px;
}
.filter-container {
  display: flex;
  align-items: center;
  margin-bottom: 10px;
}
.filter-container label {
  margin-right: 10px;
}
.course-info {
  padding: 10px 0px 0px 20px;
}

.course-info h1 {
  font-size: 24px;
  color: #333;
  margin-bottom: 10px;
}

.course-info div {
  font-size: 18px;
  color: #666;
}

.complete {
  color: #007bff;
}
.not-complete {
  color: #dc3545;
}
.nombre-totale {
  margin-top: 10px;
}
.link {
  color: #61b521 !important;
  text-decoration: underline !important;
  margin-bottom: 15px;
}
</style>
